CF1982F Sorting Problem Again 題解

Athanasy發表於2024-06-26

題目連結:CF 或者 洛谷

解題思路

這題放 \(F\) 虛高了。做法很多,講一個比較直觀的前提想法:

我們定義個輔助陣列 \(v\),滿足 \(v[i]=a[i] \ge a[i-1]\),那麼一個直觀的想法:

\(v\) 陣列可能長這樣:\(11110010110001111\)。我們需要做的很顯然就是找到一對 \([l,r]\),使得這個範圍內的排序以後,\(v\) 變為了 \(111111111111\)

一個非常直觀的想法就是先找出 \(L=left0\)\(R=right0\),即最左邊的 \(0\) 與 最右邊的 \(0\)

這裡稍微注意一下,\(v[left0]<v[left0-1]\),所以其實我們這個時候要修改的範圍其實應該是需要包括 \(left0-1\) 的,否則無論怎麼排序,\(a[left0]\) 一定在 \(a[left0-1]\) 的右側不滿足題意。所以不妨讓:\(L=left0-1,R=right0\)

那麼我們難道翻轉下 \([L,R]\) 就一定能讓中間的所有 \(0 \rightarrow 1\) 嗎?這次樣例給的很充分,觀察樣例 \(2\) 你就會發現一個事實:

當你將 \([L,R]\) 內排序以後,\([L+1,R]\) 一定都是 \(1\),滿足 \(a[i]\ge a[i-1]\),但你觀察一下,\(a[L]\ge a[L-1]\)\(a[R+1] \ge a[R]\),這兩個是不一定成立的,這取決於以下事實:

不妨設:\(Min=\min{a[l\sim r]},Max=\max{a[l \sim r]}\)。我們很容易知道一個事實,假設答案為 \([ansL,ansR]\),那麼一定有

\(a[1\sim ansL-1] \le Min\)\(a[ansR+1,n] \ge Max\) 成立。所以真正的 \(ansL\)\(ansR\) 還需要往左右兩邊去確定。

實現方式

關於問題 \(1\),我們可以預處理出 \(v\) 陣列,而每次修改 \(a[pos]=val\),我們觀察到 \(v\) 陣列至多變化兩個位置:\(v[pos],v[pos+1]\),那麼其實修改就僅僅只是單點修改問題。關於查詢 \(left0\)\(right0\),這是一個很經典的問題,本身這個 \(01\) 並無單調性,但我們可以增加 \(minVal\) 屬性,或者 \(sum\) 屬性,這樣即具備單調性。

對於 \(sum\) 屬性,由於都是非負數,那麼和區間長度呈正相關,你二分的 \(check\) 僅僅是 \(len?=sum\) 即可。

對於 \(min\) 屬性,如果區間出現過 \(0\),就往區間裡找(此時 \(min=0\)),沒有就往外找 \(0\)。從左往右或者從右往左二分。

上述過程的實現方式:由於涉及到單修和前字尾上二分。所以常見的我們有這幾種思路:

  1. \(\text{二分+線段樹/樹狀陣列}\)

  2. \(\text{線段樹/文藝平衡樹上二分}\)

  3. \(\text{樹狀陣列上倍增}\)

關於第二個問題,我們需要找到前字尾中滿足 \(\le Min\) 的最大位置 \(l\),還有 \(\ge Max\) 的最小位置 \(r\),而 \(l+1\)\(r-1\) 才是所求,所以可以查第一個不滿足點即可。

做法很多:

  1. \(\text{二分+區間線段樹或者文藝平衡樹維護區間最值}\)

  2. \(\text{區間線段樹或者文藝平衡樹維護區間最值,樹上二分}\)

  3. \(\text{樹狀陣列上倍增}\)

  4. \(\text{值域作軸,權值為下標,維護區間最小和最大值,直接做值域上的限制查詢}\),可以用:\(\text{權值樹狀陣列、權值線段樹、普通平衡樹等等}\)

其中注意一點,就是可能會出現不存在的 \(l\)\(r\),或者 \(pre\)\(suf\) 完全滿足。我們可以為了減少特判增加哨兵節點:\(a[0]=-INF,a[n+1]=INF\)\(v[0]=v[n+1]=1\) 即可。

這裡使用的是線段樹上二分的做法,具體參見程式碼實現。

參照程式碼
#include <bits/stdc++.h>

// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")

// #define isPbdsFile

#ifdef isPbdsFile

#include <bits/extc++.h>

#else

#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/trie_policy.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/list_update_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/exception.hpp>
#include <ext/rope>

#endif

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> tii;
typedef tuple<ll, ll, ll> tll;
typedef unsigned int ui;
typedef unsigned long long ull;
#define hash1 unordered_map
#define hash2 gp_hash_table
#define hash3 cc_hash_table
#define stdHeap std::priority_queue
#define pbdsHeap __gnu_pbds::priority_queue
#define sortArr(a, n) sort(a+1,a+n+1)
#define all(v) v.begin(),v.end()
#define yes cout<<"YES"
#define no cout<<"NO"
#define Spider ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define MyFile freopen("..\\input.txt", "r", stdin),freopen("..\\output.txt", "w", stdout);
#define forn(i, a, b) for(int i = a; i <= b; i++)
#define forv(i, a, b) for(int i=a;i>=b;i--)
#define ls(x) (x<<1)
#define rs(x) (x<<1|1)
#define endl '\n'
//用於Miller-Rabin
[[maybe_unused]] static int Prime_Number[13] = {0, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};

template <typename T>
int disc(T* a, int n)
{
    return unique(a + 1, a + n + 1) - (a + 1);
}

template <typename T>
T lowBit(T x)
{
    return x & -x;
}

template <typename T>
T Rand(T l, T r)
{
    static mt19937 Rand(time(nullptr));
    uniform_int_distribution<T> dis(l, r);
    return dis(Rand);
}

template <typename T1, typename T2>
T1 modt(T1 a, T2 b)
{
    return (a % b + b) % b;
}

template <typename T1, typename T2, typename T3>
T1 qPow(T1 a, T2 b, T3 c)
{
    a %= c;
    T1 ans = 1;
    for (; b; b >>= 1, (a *= a) %= c) if (b & 1) (ans *= a) %= c;
    return modt(ans, c);
}

template <typename T>
void read(T& x)
{
    x = 0;
    T sign = 1;
    char ch = getchar();
    while (!isdigit(ch))
    {
        if (ch == '-') sign = -1;
        ch = getchar();
    }
    while (isdigit(ch))
    {
        x = (x << 3) + (x << 1) + (ch ^ 48);
        ch = getchar();
    }
    x *= sign;
}

template <typename T, typename... U>
void read(T& x, U&... y)
{
    read(x);
    read(y...);
}

template <typename T>
void write(T x)
{
    if (typeid(x) == typeid(char)) return;
    if (x < 0) x = -x, putchar('-');
    if (x > 9) write(x / 10);
    putchar(x % 10 ^ 48);
}

template <typename C, typename T, typename... U>
void write(C c, T x, U... y)
{
    write(x), putchar(c);
    write(c, y...);
}


template <typename T11, typename T22, typename T33>
struct T3
{
    T11 one;
    T22 tow;
    T33 three;

    bool operator<(const T3 other) const
    {
        if (one == other.one)
        {
            if (tow == other.tow) return three < other.three;
            return tow < other.tow;
        }
        return one < other.one;
    }

    T3()
    {
        one = tow = three = 0;
    }

    T3(T11 one, T22 tow, T33 three) : one(one), tow(tow), three(three)
    {
    }
};

template <typename T1, typename T2>
void uMax(T1& x, T2 y)
{
    if (x < y) x = y;
}

template <typename T1, typename T2>
void uMin(T1& x, T2 y)
{
    if (x > y) x = y;
}

constexpr int N = 5e5 + 10;
constexpr int INF = 1e9 + 7;
int n, q;
int a[N], v[N]; //v[i]=a[i]>=a[i-1]
//ordMin 為v的區間最小值
//valMin與valMax為a陣列的區間最值
struct Node
{
    int ordMin;
    int valMin, valMax;
} node[N << 2];

#define ordMin(x) node[x].ordMin
#define valMin(x) node[x].valMin
#define valMax(x) node[x].valMax

inline void pushUp(const int curr)
{
    valMin(curr) = min(valMin(ls(curr)),valMin(rs(curr)));
    valMax(curr) = max(valMax(ls(curr)),valMax(rs(curr)));
    ordMin(curr) = min(ordMin(ls(curr)),ordMin(rs(curr)));
}

inline void update(const int curr, const int pos, const int ordVal, const int val, const int l = 0, const int r = n + 1)
{
    if (l == r)
    {
        valMin(curr) = valMax(curr) = val;
        ordMin(curr) = ordVal;
        return;
    }
    const int mid = l + r >> 1;
    if (pos <= mid) update(ls(curr), pos, ordVal, val, l, mid);
    else update(rs(curr), pos, ordVal, val, mid + 1, r);
    pushUp(curr);
}

inline void build(const int curr = 1, const int l = 0, const int r = n + 1)
{
    if (l == r)
    {
        valMax(curr) = valMin(curr) = a[l];
        ordMin(curr) = v[l];
        return;
    }
    const int mid = l + r >> 1;
    build(ls(curr), l, mid);
    build(rs(curr), mid + 1, r);
    pushUp(curr);
}

//二分出left0
inline int ordLeft(const int curr = 1, const int l = 0, const int r = n + 1)
{
    if (l == r) return l;
    const int mid = l + r >> 1;
    if (ordMin(ls(curr)) != 1) return ordLeft(ls(curr), l, mid);
    return ordLeft(rs(curr), mid + 1, r);
}

//二分出right0
inline int ordRight(const int curr = 1, const int l = 0, const int r = n + 1)
{
    if (l == r) return l;
    const int mid = l + r >> 1;
    if (ordMin(rs(curr)) != 1) return ordRight(rs(curr), mid + 1, r);
    return ordRight(ls(curr), l, mid);
}

//查詢r<=R,且pre>val的第一個下標
inline int valPre(const int curr, const int R, const int val, const int l = 0, const int r = n + 1)
{
    const int mid = l + r >> 1;
    if (r <= R)
    {
        if (l == r) return valMax(curr) > val ? l : -1;
        if (valMax(ls(curr)) > val) return valPre(ls(curr), R, val, l, mid);
        return valPre(rs(curr), R, val, mid + 1, r);
    }
    const int ansL = valPre(ls(curr), R, val, l, mid);
    return ansL != -1 ? ansL : valPre(rs(curr), R, val, mid + 1, r);
}

//查詢l>=L,且suf<val的第一個下標
inline int valSuf(const int curr, const int L, const int val, const int l = 0, const int r = n + 1)
{
    const int mid = l + r >> 1;
    if (L <= l)
    {
        if (l == r) return valMin(curr) < val ? l : -1;
        if (valMin(rs(curr)) < val) return valSuf(rs(curr), L, val, mid + 1, r);
        return valSuf(ls(curr), L, val, l, mid);
    }
    const int ansR = valSuf(rs(curr), L, val, mid + 1, r);
    return ansR != -1 ? ansR : valSuf(ls(curr), L, val, l, mid);
}

pii operator+(const pii& L, const pii& R)
{
    return pii(min(L.first, R.first), max(L.second, R.second));
}

inline pii query(const int curr, const int l, const int r, const int s = 0, const int e = n + 1)
{
    if (l == s and e == r) return pii(valMin(curr),valMax(curr));
    const int mid = s + e >> 1;
    if (r <= mid) return query(ls(curr), l, r, s, mid);
    if (l > mid) return query(rs(curr), l, r, mid + 1, e);
    return query(ls(curr), l, mid, s, mid) + query(rs(curr), mid + 1, r, mid + 1, e);
}

inline void getAns()
{
    const int L = ordLeft() - 1; //left0-1
    if (L == n)
    {
        cout << -1 << ' ' << -1 << endl;
        return;
    }
    const int R = ordRight(); //right0
    const auto [mi,mx] = query(1, L, R); //[L,R]上的Min,Max
    const int l = valPre(1, L, mi); //pre>val的第一個下標,也可以不用座標域限制,直接查詢和L取min
    const int r = valSuf(1, R, mx); //suf<val的第一個下標,也可以不用座標域限制,直接查詢和R取max
    cout << (l == -1 ? L : l) << ' ' << (r == -1 ? R : r) << endl; //不存在就是全部滿足
}

inline void solve()
{
    cin >> n;
    a[0] = -INF, a[n + 1] = INF;
    v[0] = v[n + 1] = 1;
    forn(i, 1, n) cin >> a[i], v[i] = a[i] >= a[i - 1];
    build();
    getAns();
    cin >> q;
    while (q--)
    {
        int pos, val;
        cin >> pos >> val;
        a[pos] = val;
        v[pos] = a[pos] >= a[pos - 1];
        v[pos + 1] = a[pos + 1] >= a[pos];
        update(1, pos, v[pos], a[pos]);
        update(1, pos + 1, v[pos + 1], a[pos + 1]);
        getAns();
    }
}

signed int main()
{
    // MyFile
    Spider
    //------------------------------------------------------
    // clock_t start = clock();
    int test = 1;
    //    read(test);
    cin >> test;
    forn(i, 1, test) solve();
    //    while (cin >> n, n)solve();
    //    while (cin >> test)solve();
    // clock_t end = clock();
    // cerr << "time = " << double(end - start) / CLOCKS_PER_SEC << "s" << endl;
}

\[時間複雜度為:\ O(q\log{n}) \]

相關文章